/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "snmpCommunityEntry.h"

/*
 * snmpCommunityEntry_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             snmpCommunityEntry_variables_oid[] =
    { 1, 3, 6, 1, 6, 3, 18, 1, 1, 1 };

/*
 * variable4 snmpCommunityEntry_variables:
 *   this variable defines function callbacks and type return information 
 *   for the snmpCommunityEntry mib section 
 */

struct variable1 snmpCommunityEntry_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define SNMPCOMMUNITYINDEX		1
    {SNMPCOMMUNITYINDEX, ASN_OCTET_STR, RONLY, var_snmpCommunityEntry, 1,
     {1}},
#define SNMPCOMMUNITYNAME		2
    {SNMPCOMMUNITYNAME, ASN_OCTET_STR, RWRITE, var_snmpCommunityEntry, 1,
     {2}},
#define SNMPCOMMUNITYSECURITYNAME		3
    {SNMPCOMMUNITYSECURITYNAME, ASN_OCTET_STR, RWRITE,
     var_snmpCommunityEntry, 1, {3}},
#define SNMPCOMMUNITYCONTEXTENGINEID		4
    {SNMPCOMMUNITYCONTEXTENGINEID, ASN_OCTET_STR, RWRITE,
     var_snmpCommunityEntry, 1, {4}},
#define SNMPCOMMUNITYCONTEXTNAME		5
    {SNMPCOMMUNITYCONTEXTNAME, ASN_OCTET_STR, RWRITE,
     var_snmpCommunityEntry, 1, {5}},
#define SNMPCOMMUNITYTRANSPORTTAG		6
    {SNMPCOMMUNITYTRANSPORTTAG, ASN_OCTET_STR, RWRITE,
     var_snmpCommunityEntry, 1, {6}},
#define SNMPCOMMUNITYSTORAGETYPE		7
    {SNMPCOMMUNITYSTORAGETYPE, ASN_INTEGER, RWRITE, var_snmpCommunityEntry,
     1, {7}},
#define SNMPCOMMUNITYSTATUS		8
    {SNMPCOMMUNITYSTATUS, ASN_INTEGER, RWRITE, var_snmpCommunityEntry, 1,
     {8}},

};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the snmpCommunityEntry module */
void
init_snmpCommunityEntry(void)
{

    DEBUGMSGTL(("snmpCommunityEntry", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("snmpCommunityEntry", snmpCommunityEntry_variables,
                 variable1, snmpCommunityEntry_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_snmpCommunityEntry():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct long_value.
 *     You should also correct the long_value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_snmpCommunityEntry(struct variable *vp,
                       oid * name,
                       size_t *length,
                       int exact,
                       size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

    com2SecEntry 		*gp;
    oid            *groupSubtree;
    int             groupSubtreeLen;
    int             secmodel;
    char            secname[VACMSTRINGLEN], *cp;
    
		long long_value=0;
#if 0
{
char a[128]="";
char b[128]="";
int i;
for(i=0;i<vp->namelen;i++)
sprintf(a,"%s%d-",a,vp->name[i]);
for(i=0;i<*length;i++)
sprintf(b,"%s%d-",a,*(name+i));
snmp_log(LOG_ERR, "CommunityEntry: vp->magic:%d vp->name:%s name:%s exact:%d.\n", vp->magic,a,b,exact);
}
#endif
    /*
     * Set up write_method first, in case we return NULL before getting to
     * the switch (vp->magic) below.  In some of these cases, we still want
     * to call the appropriate write_method, if only to have it return the
     * appropriate error.  
     */
    if (memcmp(name, vp->name, sizeof(oid) * vp->namelen) != 0) {
        memcpy(name, vp->name, sizeof(oid) * vp->namelen);
        *length = vp->namelen;
    }
    if (exact) {
    		return NULL;
#if 0    	
        if (*length < 13)
            return NULL;

        secmodel = name[11];
        groupSubtree = name + 13;
        groupSubtreeLen = *length - 13;
        if ( name[12] != groupSubtreeLen )
            return 0;		/* Either extra subids, or an incomplete string */
        cp = secname;
        while (groupSubtreeLen-- > 0) {
            if (*groupSubtree > 255)
                return 0;       /* illegal value */
            if (cp - secname > VACM_MAX_STRING)
                return 0;
            *cp++ = (char) *groupSubtree++;
        }
        *cp = 0;
snmp_log(LOG_ERR, "CommunityEntry: secname:%s secmodel:%d.\n", secname,secmodel);
        //gp = vacm_getGroupEntry(secmodel, secname);
#endif        
    } else {
        secmodel = *length > 11 ? name[11] : 0;
       	secmodel++;
				//snmp_log(LOG_ERR, "length:%d, secmodel:%d.\n", *length, secmodel);
#if 0
        groupSubtree = name + 12;
        groupSubtreeLen = *length - 12;
        cp = secname;
        while (groupSubtreeLen-- > 0) {
            if (*groupSubtree > 255)
                return 0;       /* illegal value */
            if (cp - secname > VACM_MAX_STRING)
                return 0;
            *cp++ = (char) *groupSubtree++;
        }
        *cp = 0;
#endif
				//snmp_log(LOG_ERR, "vacm_sec2group: secname:%s secmodel:%d.\n", secname,secmodel);    
        vacm_scancom2SecEntryInit();
        while ((gp = com2SecEntry_scanEntryNext()) != NULL) {
            if (gp->index == secmodel)
            //if (gp->index >= secmodel)
                break;            
        }

        if (gp)  {
	
           	name[11] = gp->index;            	
            *length = 12;

            cp = gp->secName;
            while (*cp) {
                name[(*length)++] = *cp++;
            }
#if 0
{
char b[128]="";
int i;
for(i=0;i<*length;i++)
sprintf(b,"%s%d-",b,*(name+i));
snmp_log(LOG_ERR, "com2sec2: name:%s.\n", b);
}
#endif            

        }
    }

    if (gp == NULL) {
        return NULL;
    }
    

		//snmp_log(LOG_ERR, "gp->index:%d.\n", gp->index);
    *var_len = sizeof(long_return);

    /*
     * this is where we do the long_value assignments for the mib results.
     */

    switch (vp->magic) {
/*    case SNMPCOMMUNITYINDEX:
        long_return = long_value;         
        return (u_char *) & long_return;*/
        
    case SNMPCOMMUNITYNAME:
        *write_method = write_snmpCommunityName;
        *var_len = strlen(gp->community);
        return (u_char *) gp->community;
    case SNMPCOMMUNITYSECURITYNAME:
        *write_method = write_snmpCommunitySecurityName;
        *var_len = strlen(gp->secName);
        return (u_char *) gp->secName;
    case SNMPCOMMUNITYCONTEXTENGINEID:
        *write_method = write_snmpCommunityContextEngineID;
        long_return = long_value;            /* XXX */
        return (u_char *) & long_return;
    case SNMPCOMMUNITYCONTEXTNAME:
        *write_method = write_snmpCommunityContextName;
        *var_len = strlen(gp->contextName);
        return (u_char *) gp->contextName;
    case SNMPCOMMUNITYTRANSPORTTAG:
        *write_method = write_snmpCommunityTransportTag;
        long_return = long_value;            /* XXX */
        return (u_char *) & long_return;
    case SNMPCOMMUNITYSTORAGETYPE:
        *write_method = write_snmpCommunityStorageType;
        long_return = long_value;            /* XXX */
        return (u_char *) & long_return;
    case SNMPCOMMUNITYSTATUS:
        *write_method = write_snmpCommunityStatus;
        long_return = long_value;            /* XXX */
        return (u_char *) & long_return;
    default:
        ERROR_MSG("");
    }
    return NULL;
}





int
write_snmpCommunityName(int action,
                        u_char * var_val,
                        u_char var_val_type,
                        size_t var_val_len,
                        u_char * statP, oid * name, size_t name_len)
{
    char            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(char)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snmpCommunitySecurityName(int action,
                                u_char * var_val,
                                u_char var_val_type,
                                size_t var_val_len,
                                u_char * statP,
                                oid * name, size_t name_len)
{
    char            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(char)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snmpCommunityContextEngineID(int action,
                                   u_char * var_val,
                                   u_char var_val_type,
                                   size_t var_val_len,
                                   u_char * statP,
                                   oid * name, size_t name_len)
{
    char            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(char)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snmpCommunityContextName(int action,
                               u_char * var_val,
                               u_char var_val_type,
                               size_t var_val_len,
                               u_char * statP, oid * name, size_t name_len)
{
    char            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(char)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snmpCommunityTransportTag(int action,
                                u_char * var_val,
                                u_char var_val_type,
                                size_t var_val_len,
                                u_char * statP,
                                oid * name, size_t name_len)
{
    char            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(char)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snmpCommunityStorageType(int action,
                               u_char * var_val,
                               u_char var_val_type,
                               size_t var_val_len,
                               u_char * statP, oid * name, size_t name_len)
{
    long            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_snmpCommunityStatus(int action,
                          u_char * var_val,
                          u_char var_val_type,
                          size_t var_val_len,
                          u_char * statP, oid * name, size_t name_len)
{
    long            long_value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr,
                    "write to snmpCommunityEntry not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to snmpCommunityEntry: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        break;

    case RESERVE2:
        size = var_val_len;
        long_value = *(long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'long_value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}
