/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.table_data.conf 15999 2007-03-25 22:32:02Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "snmpCommunityMIB.h"

/** Initializes the snmpCommunityMIB module */
void
init_snmpCommunityMIB(void)
{
    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_snmpCommunityTable();
    initialize_table_snmpTargetAddrExtTable();
}

# Determine the first/last column names

/** Initialize the snmpCommunityTable table by defining its contents and how it's structured */
void
initialize_table_snmpCommunityTable(void)
{
    static oid      snmpCommunityTable_oid[] =
        { 1, 3, 6, 1, 6, 3, 18, 1, 1 };
    size_t          snmpCommunityTable_oid_len =
        OID_LENGTH(snmpCommunityTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;

    reg =
        netsnmp_create_handler_registration("snmpCommunityTable",
                                            snmpCommunityTable_handler,
                                            snmpCommunityTable_oid,
                                            snmpCommunityTable_oid_len,
                                            HANDLER_CAN_RWRITE);

    table_data = netsnmp_tdata_create_table("snmpCommunityTable", 0);
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_OCTET_STR, /* index: snmpCommunityIndex */
                                     0);

    table_info->min_column = COLUMN_SNMPCOMMUNITYNAME;
    table_info->max_column = COLUMN_SNMPCOMMUNITYSTATUS;

    netsnmp_tdata_register(reg, table_data, table_info);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct snmpCommunityTable_entry {
    /*
     * Index values 
     */
    char            snmpCommunityIndex[NNN];
    size_t          snmpCommunityIndex_len;

    /*
     * Column values 
     */
    char            snmpCommunityName[NNN];
    size_t          snmpCommunityName_len;
    char            old_snmpCommunityName[NNN];
    size_t          old_snmpCommunityName_len;
    char            snmpCommunitySecurityName[NNN];
    size_t          snmpCommunitySecurityName_len;
    char            old_snmpCommunitySecurityName[NNN];
    size_t          old_snmpCommunitySecurityName_len;
    char            snmpCommunityContextEngineID[NNN];
    size_t          snmpCommunityContextEngineID_len;
    char            old_snmpCommunityContextEngineID[NNN];
    size_t          old_snmpCommunityContextEngineID_len;
    char            snmpCommunityContextName[NNN];
    size_t          snmpCommunityContextName_len;
    char            old_snmpCommunityContextName[NNN];
    size_t          old_snmpCommunityContextName_len;
    char            snmpCommunityTransportTag[NNN];
    size_t          snmpCommunityTransportTag_len;
    char            old_snmpCommunityTransportTag[NNN];
    size_t          old_snmpCommunityTransportTag_len;
    long            snmpCommunityStorageType;
    long            old_snmpCommunityStorageType;
    long            snmpCommunityStatus;

    int             valid;
};

/*
 * create a new row in the table 
 */
netsnmp_tdata_row *
snmpCommunityTable_createEntry(netsnmp_tdata * table_data,
                               char *snmpCommunityIndex,
                               size_t snmpCommunityIndex_len)
{
    struct snmpCommunityTable_entry *entry;
    netsnmp_tdata_row *row;

    entry = SNMP_MALLOC_TYPEDEF(struct snmpCommunityTable_entry);
    if (!entry)
        return NULL;

    row = netsnmp_tdata_create_row();
    if (!row) {
        SNMP_FREE(entry);
        return NULL;
    }
    row->data = entry;
    memcpy(entry->snmpCommunityIndex, snmpCommunityIndex,
           snmpCommunityIndex_len);
    entry->snmpCommunityIndex_len = snmpCommunityIndex_len;
    netsnmp_tdata_row_add_index(row, ASN_OCTET_STR,
                                entry->snmpCommunityIndex,
                                snmpCommunityIndex_len);
    netsnmp_tdata_add_row(table_data, row);
    return row;
}

/*
 * remove a row from the table 
 */
void
snmpCommunityTable_removeEntry(netsnmp_tdata * table_data,
                               netsnmp_tdata_row * row)
{
    struct snmpCommunityTable_entry *entry;

    if (!row)
        return;                 /* Nothing to remove */
    entry = (struct snmpCommunityTable_entry *)
        netsnmp_tdata_remove_and_delete_row(table_data, row);
    if (entry)
        SNMP_FREE(entry);       /* XXX - release any other internal resources */
}


/** handles requests for the snmpCommunityTable table */
int
snmpCommunityTable_handler(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    netsnmp_tdata  *table_data;
    netsnmp_tdata_row *table_row;
    struct snmpCommunityTable_entry *table_entry;
    int             ret;

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYNAME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         snmpCommunityName,
                                         table_entry->
                                         snmpCommunityName_len);
                break;
            case COLUMN_SNMPCOMMUNITYSECURITYNAME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         snmpCommunitySecurityName,
                                         table_entry->
                                         snmpCommunitySecurityName_len);
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTENGINEID:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         snmpCommunityContextEngineID,
                                         table_entry->
                                         snmpCommunityContextEngineID_len);
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTNAME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         snmpCommunityContextName,
                                         table_entry->
                                         snmpCommunityContextName_len);
                break;
            case COLUMN_SNMPCOMMUNITYTRANSPORTTAG:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         snmpCommunityTransportTag,
                                         table_entry->
                                         snmpCommunityTransportTag_len);
                break;
            case COLUMN_SNMPCOMMUNITYSTORAGETYPE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           snmpCommunityStorageType);
                break;
            case COLUMN_SNMPCOMMUNITYSTATUS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           snmpCommunityStatus);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

        /*
         * Write-support
         */
    case MODE_SET_RESERVE1:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYNAME:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              snmpCommunityName));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPCOMMUNITYSECURITYNAME:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              snmpCommunitySecurityName));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTENGINEID:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              snmpCommunityContextEngineID));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTNAME:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              snmpCommunityContextName));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPCOMMUNITYTRANSPORTTAG:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              snmpCommunityTransportTag));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPCOMMUNITYSTORAGETYPE:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPCOMMUNITYSTATUS:
                ret = netsnmp_check_vb_rowstatus(request->requestvb,
                                                 (table_entry ? RS_ACTIVE :
                                                  RS_NONEXISTENT));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOTWRITABLE);
                return SNMP_ERR_NOERROR;
            }
        }
        break;

    case MODE_SET_RESERVE2:
        for (request = requests; request; request = request->next) {
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYSTATUS:
                switch (*request->requestvb->val.integer) {
                case RS_CREATEANDGO:
                case RS_CREATEANDWAIT:
                    table_row =
                        snmpCommunityTable_createEntry(table_data,
                                                       table_info->
                                                       indexes->val.string,
                                                       table_info->
                                                       indexes->val_len);
                    if (table_row) {
                        netsnmp_insert_tdata_row(request, table_row);
                    } else {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_RESOURCEUNAVAILABLE);
                        return SNMP_ERR_NOERROR;
                    }
                }
            }
        }
        break;

    case MODE_SET_FREE:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYSTATUS:
                switch (*request->requestvb->val.integer) {
                case RS_CREATEANDGO:
                case RS_CREATEANDWAIT:
                    if (table_entry && !table_entry->valid) {
                        snmpCommunityTable_removeEntry(table_data,
                                                       table_row);
                    }
                }
            }
        }
        break;

    case MODE_SET_ACTION:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYNAME:
                memcpy(table_entry->old_snmpCommunityName,
                       table_entry->snmpCommunityName,
                       sizeof(table_entry->snmpCommunityName));
                table_entry->old_snmpCommunityName_len =
                    table_entry->snmpCommunityName_len;
                memset(table_entry->snmpCommunityName, 0,
                       sizeof(table_entry->snmpCommunityName));
                memcpy(table_entry->snmpCommunityName,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->snmpCommunityName_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_SNMPCOMMUNITYSECURITYNAME:
                memcpy(table_entry->old_snmpCommunitySecurityName,
                       table_entry->snmpCommunitySecurityName,
                       sizeof(table_entry->snmpCommunitySecurityName));
                table_entry->old_snmpCommunitySecurityName_len =
                    table_entry->snmpCommunitySecurityName_len;
                memset(table_entry->snmpCommunitySecurityName, 0,
                       sizeof(table_entry->snmpCommunitySecurityName));
                memcpy(table_entry->snmpCommunitySecurityName,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->snmpCommunitySecurityName_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTENGINEID:
                memcpy(table_entry->old_snmpCommunityContextEngineID,
                       table_entry->snmpCommunityContextEngineID,
                       sizeof(table_entry->snmpCommunityContextEngineID));
                table_entry->old_snmpCommunityContextEngineID_len =
                    table_entry->snmpCommunityContextEngineID_len;
                memset(table_entry->snmpCommunityContextEngineID, 0,
                       sizeof(table_entry->snmpCommunityContextEngineID));
                memcpy(table_entry->snmpCommunityContextEngineID,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->snmpCommunityContextEngineID_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTNAME:
                memcpy(table_entry->old_snmpCommunityContextName,
                       table_entry->snmpCommunityContextName,
                       sizeof(table_entry->snmpCommunityContextName));
                table_entry->old_snmpCommunityContextName_len =
                    table_entry->snmpCommunityContextName_len;
                memset(table_entry->snmpCommunityContextName, 0,
                       sizeof(table_entry->snmpCommunityContextName));
                memcpy(table_entry->snmpCommunityContextName,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->snmpCommunityContextName_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_SNMPCOMMUNITYTRANSPORTTAG:
                memcpy(table_entry->old_snmpCommunityTransportTag,
                       table_entry->snmpCommunityTransportTag,
                       sizeof(table_entry->snmpCommunityTransportTag));
                table_entry->old_snmpCommunityTransportTag_len =
                    table_entry->snmpCommunityTransportTag_len;
                memset(table_entry->snmpCommunityTransportTag, 0,
                       sizeof(table_entry->snmpCommunityTransportTag));
                memcpy(table_entry->snmpCommunityTransportTag,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->snmpCommunityTransportTag_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_SNMPCOMMUNITYSTORAGETYPE:
                table_entry->old_snmpCommunityStorageType =
                    table_entry->snmpCommunityStorageType;
                table_entry->snmpCommunityStorageType =
                    *request->requestvb->val.integer;
                break;
            }
        }
        /*
         * Check the internal consistency of an active row 
         */
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYSTATUS:
                switch (*request->requestvb->val.integer) {
                case RS_ACTIVE:
                case RS_CREATEANDGO:
                    if ( /* XXX */ ) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_INCONSISTENTVALUE);
                        return SNMP_ERR_NOERROR;
                    }
                }
            }
        }
        break;

    case MODE_SET_UNDO:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYNAME:
                memcpy(table_entry->snmpCommunityName,
                       table_entry->old_snmpCommunityName,
                       sizeof(table_entry->snmpCommunityName));
                memset(table_entry->old_snmpCommunityName, 0,
                       sizeof(table_entry->snmpCommunityName));
                table_entry->snmpCommunityName_len =
                    table_entry->old_snmpCommunityName_len;
                break;
            case COLUMN_SNMPCOMMUNITYSECURITYNAME:
                memcpy(table_entry->snmpCommunitySecurityName,
                       table_entry->old_snmpCommunitySecurityName,
                       sizeof(table_entry->snmpCommunitySecurityName));
                memset(table_entry->old_snmpCommunitySecurityName, 0,
                       sizeof(table_entry->snmpCommunitySecurityName));
                table_entry->snmpCommunitySecurityName_len =
                    table_entry->old_snmpCommunitySecurityName_len;
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTENGINEID:
                memcpy(table_entry->snmpCommunityContextEngineID,
                       table_entry->old_snmpCommunityContextEngineID,
                       sizeof(table_entry->snmpCommunityContextEngineID));
                memset(table_entry->old_snmpCommunityContextEngineID, 0,
                       sizeof(table_entry->snmpCommunityContextEngineID));
                table_entry->snmpCommunityContextEngineID_len =
                    table_entry->old_snmpCommunityContextEngineID_len;
                break;
            case COLUMN_SNMPCOMMUNITYCONTEXTNAME:
                memcpy(table_entry->snmpCommunityContextName,
                       table_entry->old_snmpCommunityContextName,
                       sizeof(table_entry->snmpCommunityContextName));
                memset(table_entry->old_snmpCommunityContextName, 0,
                       sizeof(table_entry->snmpCommunityContextName));
                table_entry->snmpCommunityContextName_len =
                    table_entry->old_snmpCommunityContextName_len;
                break;
            case COLUMN_SNMPCOMMUNITYTRANSPORTTAG:
                memcpy(table_entry->snmpCommunityTransportTag,
                       table_entry->old_snmpCommunityTransportTag,
                       sizeof(table_entry->snmpCommunityTransportTag));
                memset(table_entry->old_snmpCommunityTransportTag, 0,
                       sizeof(table_entry->snmpCommunityTransportTag));
                table_entry->snmpCommunityTransportTag_len =
                    table_entry->old_snmpCommunityTransportTag_len;
                break;
            case COLUMN_SNMPCOMMUNITYSTORAGETYPE:
                table_entry->snmpCommunityStorageType =
                    table_entry->old_snmpCommunityStorageType;
                table_entry->old_snmpCommunityStorageType = 0;
                break;
            case COLUMN_SNMPCOMMUNITYSTATUS:
                switch (*request->requestvb->val.integer) {
                case RS_CREATEANDGO:
                case RS_CREATEANDWAIT:
                    if (table_entry && !table_entry->valid) {
                        snmpCommunityTable_removeEntry(table_data,
                                                       table_row);
                    }
                }
                break;
            }
        }
        break;

    case MODE_SET_COMMIT:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpCommunityTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPCOMMUNITYSTATUS:
                switch (*request->requestvb->val.integer) {
                case RS_CREATEANDGO:
                    table_entry->valid = 1;
                    /*
                     * Fall-through 
                     */
                case RS_ACTIVE:
                    table_entry->snmpCommunityStatus = RS_ACTIVE;
                    break;

                case RS_CREATEANDWAIT:
                    table_entry->valid = 1;
                    /*
                     * Fall-through 
                     */
                case RS_NOTINSERVICE:
                    table_entry->snmpCommunityStatus = RS_NOTINSERVICE;
                    break;

                case RS_DESTROY:
                    snmpCommunityTable_removeEntry(table_data, table_row);
                }
            }
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

# Determine the first/last column names

/** Initialize the snmpTargetAddrExtTable table by defining its contents and how it's structured */
void
initialize_table_snmpTargetAddrExtTable(void)
{
    static oid      snmpTargetAddrExtTable_oid[] =
        { 1, 3, 6, 1, 6, 3, 18, 1, 2 };
    size_t          snmpTargetAddrExtTable_oid_len =
        OID_LENGTH(snmpTargetAddrExtTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;

    reg =
        netsnmp_create_handler_registration("snmpTargetAddrExtTable",
                                            snmpTargetAddrExtTable_handler,
                                            snmpTargetAddrExtTable_oid,
                                            snmpTargetAddrExtTable_oid_len,
                                            HANDLER_CAN_RWRITE);

    table_data = netsnmp_tdata_create_table("snmpTargetAddrExtTable", 0);
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_OCTET_STR, /* index: snmpTargetAddrName */
                                     0);

    table_info->min_column = COLUMN_SNMPTARGETADDRTMASK;
    table_info->max_column = COLUMN_SNMPTARGETADDRMMS;

    netsnmp_tdata_register(reg, table_data, table_info);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct snmpTargetAddrExtTable_entry {
    /*
     * Index values 
     */
    char            snmpTargetAddrName[NNN];
    size_t          snmpTargetAddrName_len;

    /*
     * Column values 
     */
    char            snmpTargetAddrTMask[NNN];
    size_t          snmpTargetAddrTMask_len;
    char            old_snmpTargetAddrTMask[NNN];
    size_t          old_snmpTargetAddrTMask_len;
    long            snmpTargetAddrMMS;
    long            old_snmpTargetAddrMMS;

    int             valid;
};

/*
 * create a new row in the table 
 */
netsnmp_tdata_row *
snmpTargetAddrExtTable_createEntry(netsnmp_tdata * table_data,
                                   char *snmpTargetAddrName,
                                   size_t snmpTargetAddrName_len)
{
    struct snmpTargetAddrExtTable_entry *entry;
    netsnmp_tdata_row *row;

    entry = SNMP_MALLOC_TYPEDEF(struct snmpTargetAddrExtTable_entry);
    if (!entry)
        return NULL;

    row = netsnmp_tdata_create_row();
    if (!row) {
        SNMP_FREE(entry);
        return NULL;
    }
    row->data = entry;
    memcpy(entry->snmpTargetAddrName, snmpTargetAddrName,
           snmpTargetAddrName_len);
    entry->snmpTargetAddrName_len = snmpTargetAddrName_len;
    netsnmp_tdata_row_add_index(row, ASN_OCTET_STR,
                                entry->snmpTargetAddrName,
                                snmpTargetAddrName_len);
    netsnmp_tdata_add_row(table_data, row);
    return row;
}

/*
 * remove a row from the table 
 */
void
snmpTargetAddrExtTable_removeEntry(netsnmp_tdata * table_data,
                                   netsnmp_tdata_row * row)
{
    struct snmpTargetAddrExtTable_entry *entry;

    if (!row)
        return;                 /* Nothing to remove */
    entry = (struct snmpTargetAddrExtTable_entry *)
        netsnmp_tdata_remove_and_delete_row(table_data, row);
    if (entry)
        SNMP_FREE(entry);       /* XXX - release any other internal resources */
}


/** handles requests for the snmpTargetAddrExtTable table */
int
snmpTargetAddrExtTable_handler(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    netsnmp_tdata  *table_data;
    netsnmp_tdata_row *table_row;
    struct snmpTargetAddrExtTable_entry *table_entry;
    int             ret;

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpTargetAddrExtTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         snmpTargetAddrTMask,
                                         table_entry->
                                         snmpTargetAddrTMask_len);
                break;
            case COLUMN_SNMPTARGETADDRMMS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->snmpTargetAddrMMS);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

        /*
         * Write-support
         */
    case MODE_SET_RESERVE1:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpTargetAddrExtTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              snmpTargetAddrTMask));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_SNMPTARGETADDRMMS:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOTWRITABLE);
                return SNMP_ERR_NOERROR;
            }
        }
        break;

    case MODE_SET_RESERVE2:
        for (request = requests; request; request = request->next) {
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
            case COLUMN_SNMPTARGETADDRMMS:
                if (!table_row) {
                    table_row =
                        snmpTargetAddrExtTable_createEntry(table_data,
                                                           table_info->
                                                           indexes->val.
                                                           string,
                                                           table_info->
                                                           indexes->
                                                           val_len);
                    if (table_row) {
                        netsnmp_insert_tdata_row(request, table_row);
                    } else {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_RESOURCEUNAVAILABLE);
                        return SNMP_ERR_NOERROR;
                    }
                }
                break;
            }
        }
        break;

    case MODE_SET_FREE:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpTargetAddrExtTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
            case COLUMN_SNMPTARGETADDRMMS:
                if (table_entry && !table_entry->valid) {
                    snmpTargetAddrExtTable_removeEntry(table_data,
                                                       table_row);
                }
                break;
            }
        }
        break;

    case MODE_SET_ACTION:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpTargetAddrExtTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
                memcpy(table_entry->old_snmpTargetAddrTMask,
                       table_entry->snmpTargetAddrTMask,
                       sizeof(table_entry->snmpTargetAddrTMask));
                table_entry->old_snmpTargetAddrTMask_len =
                    table_entry->snmpTargetAddrTMask_len;
                memset(table_entry->snmpTargetAddrTMask, 0,
                       sizeof(table_entry->snmpTargetAddrTMask));
                memcpy(table_entry->snmpTargetAddrTMask,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->snmpTargetAddrTMask_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_SNMPTARGETADDRMMS:
                table_entry->old_snmpTargetAddrMMS =
                    table_entry->snmpTargetAddrMMS;
                table_entry->snmpTargetAddrMMS =
                    *request->requestvb->val.integer;
                break;
            }
        }
        break;

    case MODE_SET_UNDO:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpTargetAddrExtTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_row = netsnmp_tdata_extract_row(request);
            table_data = netsnmp_tdata_extract_table(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
                if (table_entry && !table_entry->valid) {
                    snmpTargetAddrExtTable_removeEntry(table_data,
                                                       table_row);
                } else {
                    memcpy(table_entry->snmpTargetAddrTMask,
                           table_entry->old_snmpTargetAddrTMask,
                           sizeof(table_entry->snmpTargetAddrTMask));
                    memset(table_entry->old_snmpTargetAddrTMask, 0,
                           sizeof(table_entry->snmpTargetAddrTMask));
                    table_entry->snmpTargetAddrTMask_len =
                        table_entry->old_snmpTargetAddrTMask_len;
                }
                break;
            case COLUMN_SNMPTARGETADDRMMS:
                if (table_entry && !table_entry->valid) {
                    snmpTargetAddrExtTable_removeEntry(table_data,
                                                       table_row);
                } else {
                    table_entry->snmpTargetAddrMMS =
                        table_entry->old_snmpTargetAddrMMS;
                    table_entry->old_snmpTargetAddrMMS = 0;
                }
                break;
            }
        }
        break;

    case MODE_SET_COMMIT:
        for (request = requests; request; request = request->next) {
            table_entry = (struct snmpTargetAddrExtTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_SNMPTARGETADDRTMASK:
            case COLUMN_SNMPTARGETADDRMMS:
                if (table_entry && !table_entry->valid) {
                    table_entry->valid = 1;
                }
            }
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}
