/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.create-dataset.conf 9375 2004-02-02 19:06:54Z rstory $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "snmpCommunityMIB.h"

/** Initialize the snmpCommunityTable table by defining its contents and how it's structured */
void
initialize_table_snmpCommunityTable(void)
{
    static oid      snmpCommunityTable_oid[] =
        { 1, 3, 6, 1, 6, 3, 18, 1, 1 };
    size_t          snmpCommunityTable_oid_len =
        OID_LENGTH(snmpCommunityTable_oid);
    netsnmp_table_data_set *table_set;

    /*
     * create the table structure itself 
     */
    table_set = netsnmp_create_table_data_set("snmpCommunityTable");

    /*
     * comment this out or delete if you don't support creation of new rows 
     */
    table_set->allow_creation = 1;

    /***************************************************
     * Adding indexes
     */
    DEBUGMSGTL(("initialize_table_snmpCommunityTable",
                "adding indexes to table snmpCommunityTable\n"));
    netsnmp_table_set_add_indexes(table_set, ASN_OCTET_STR,     /* index: snmpCommunityIndex */
                                  0);

    DEBUGMSGTL(("initialize_table_snmpCommunityTable",
                "adding column types to table snmpCommunityTable\n"));
    netsnmp_table_set_multi_add_default_row(table_set,
                                            COLUMN_SNMPCOMMUNITYINDEX,
                                            ASN_OCTET_STR, 0, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYNAME,
                                            ASN_OCTET_STR, 1, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYSECURITYNAME,
                                            ASN_OCTET_STR, 1, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYCONTEXTENGINEID,
                                            ASN_OCTET_STR, 1, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYCONTEXTNAME,
                                            ASN_OCTET_STR, 1, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYTRANSPORTTAG,
                                            ASN_OCTET_STR, 1, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYSTORAGETYPE,
                                            ASN_INTEGER, 1, NULL, 0,
                                            COLUMN_SNMPCOMMUNITYSTATUS,
                                            ASN_INTEGER, 1, NULL, 0, 0);

    /*
     * registering the table with the master agent 
     */
    /*
     * note: if you don't need a subhandler to deal with any aspects
     * of the request, change snmpCommunityTable_handler to "NULL" 
     */
    netsnmp_register_table_data_set(netsnmp_create_handler_registration
                                    ("snmpCommunityTable",
                                     snmpCommunityTable_handler,
                                     snmpCommunityTable_oid,
                                     snmpCommunityTable_oid_len,
                                     HANDLER_CAN_RWRITE), table_set, NULL);
}

/** Initialize the snmpTargetAddrExtTable table by defining its contents and how it's structured */
void
initialize_table_snmpTargetAddrExtTable(void)
{
    static oid      snmpTargetAddrExtTable_oid[] =
        { 1, 3, 6, 1, 6, 3, 18, 1, 2 };
    size_t          snmpTargetAddrExtTable_oid_len =
        OID_LENGTH(snmpTargetAddrExtTable_oid);
    netsnmp_table_data_set *table_set;

    /*
     * create the table structure itself 
     */
    table_set = netsnmp_create_table_data_set("snmpTargetAddrExtTable");

    /*
     * comment this out or delete if you don't support creation of new rows 
     */
    table_set->allow_creation = 1;

    /***************************************************
     * Adding indexes
     */
    DEBUGMSGTL(("initialize_table_snmpTargetAddrExtTable",
                "adding indexes to table snmpTargetAddrExtTable\n"));
    netsnmp_table_set_add_indexes(table_set, ASN_OCTET_STR,     /* index: snmpTargetAddrName */
                                  0);

    DEBUGMSGTL(("initialize_table_snmpTargetAddrExtTable",
                "adding column types to table snmpTargetAddrExtTable\n"));
    netsnmp_table_set_multi_add_default_row(table_set,
                                            COLUMN_SNMPTARGETADDRTMASK,
                                            ASN_OCTET_STR, 1, NULL, 0,
                                            COLUMN_SNMPTARGETADDRMMS,
                                            ASN_INTEGER, 1, NULL, 0, 0);

    /*
     * registering the table with the master agent 
     */
    /*
     * note: if you don't need a subhandler to deal with any aspects
     * of the request, change snmpTargetAddrExtTable_handler to "NULL" 
     */
    netsnmp_register_table_data_set(netsnmp_create_handler_registration
                                    ("snmpTargetAddrExtTable",
                                     snmpTargetAddrExtTable_handler,
                                     snmpTargetAddrExtTable_oid,
                                     snmpTargetAddrExtTable_oid_len,
                                     HANDLER_CAN_RWRITE), table_set, NULL);
}

/** Initializes the snmpCommunityMIB module */
void
init_snmpCommunityMIB(void)
{

    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_snmpCommunityTable();
    initialize_table_snmpTargetAddrExtTable();
}

/** handles requests for the snmpCommunityTable table, if anything else needs to be done */
int
snmpCommunityTable_handler(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{
    /*
     * perform anything here that you need to do.  The requests have
     * already been processed by the master table_dataset handler, but
     * this gives you chance to act on the request in some other way
     * if need be. 
     */
    return SNMP_ERR_NOERROR;
}

/** handles requests for the snmpTargetAddrExtTable table, if anything else needs to be done */
int
snmpTargetAddrExtTable_handler(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{
    /*
     * perform anything here that you need to do.  The requests have
     * already been processed by the master table_dataset handler, but
     * this gives you chance to act on the request in some other way
     * if need be. 
     */
    return SNMP_ERR_NOERROR;
}
