#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/if.h>
#include <sys/ioctl.h>
#include <unistd.h>
//#include "udns.h"
#include "udns_api.h"
extern char udns_conf_path[];
//extern char interface[];

void udns_set_interface(char *name)
{
//	strcpy(interface,name);
}
void udns_set_conf_path(char *path)
{
	strcpy(udns_conf_path,path);
}

unsigned long int udns_resolve_a4(char *name)
{
	struct dns_rr_a4 *rr;
	struct dns_ctx *nctx = NULL;
	unsigned long int s_addr=0;
	if(!name)
		return 0;
	if (dns_init(NULL, 0) < 0 || !(nctx = dns_new(NULL))){
		return 0;
	}
	if (dns_open(nctx) < 0){
		return 0;
	}	    
	rr = dns_resolve_a4(nctx, name, 0);
        if (!rr){
	  dns_free(nctx);
	  return 0;
	}
	s_addr=rr->dnsa4_addr[0].s_addr;
        free(rr);
	dns_free(nctx);
	return s_addr;
}
int bind_if(int sockfd,char *ifname)
{
	struct sockaddr_in sa_recv;
	struct sockaddr_in *saddr;
    	int sock=-1;
	struct ifreq ifr;

	if ((sock = socket(PF_INET, SOCK_DGRAM, 0)) == -1){
	        return -1;
	}
    	strcpy(ifr.ifr_name, ifname);
    	ifr.ifr_addr.sa_family = AF_INET;

	if (ioctl(sock, SIOCGIFADDR, &ifr)<0) {
       		close(sock);
        	return -1;
	}
    	close(sock);
	bzero((char *) &sa_recv, sizeof(sa_recv));
	sa_recv.sin_family=AF_INET;
        saddr = (struct sockaddr_in *)&ifr.ifr_addr;
        sa_recv.sin_addr.s_addr= saddr->sin_addr.s_addr;
	
	if(bind(sockfd,(struct sockaddr *) &sa_recv,sizeof(sa_recv)) == -1) {
		return -1;
	}
	return 0;
}
