/*
 *
 * tbl.c
 * Description:
 * DOCSIS interrupt table implementation
 *
 * Copyright (C) 2008 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include <linux/fs.h>		/* chrdev allocation */
#include <linux/cdev.h>

#include "hal_interrupt_cause.h"
#include "docint.h"

void docint_default_handler(unsigned int);
void docint_phy_interrupts_handler(unsigned int);

/* interrupt cause table */
dih_t docitbl[MAX_CAUSE] = {
	/* MAC_ERR1_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* MAC_ERR2_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL }, 
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_SYNC_LOST */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL }, 
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL }, 
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL }, 
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_PHY_ERR_US4 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_PHY_ERR_US3 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_PHY_ERR_US2 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_PHY_ERR_US1 */       
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_TX_ERR_US4 */ 
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_TX_ERR_US3 */ 
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_TX_ERR_US2 */ 
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_TX_ERR_US1 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_FIFO_FULL_US4 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_FIFO_FULL_US3 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_FIFO_FULL_US2 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR2_INT_FIFO_FULL_US1 */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* MAC_ERR3_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS1 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS2 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS3 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS4 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS5 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS6 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS7 */
	{ docint_default_handler, IMASKED, NULL },           /* MAC_ERR3_INT_MDD_TIMER_EXP_DS8 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS8 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS7 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS6 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS5 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS4 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS3 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS2 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_IFIFO_OVERRUN_DS1 */   
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_CNCT_SIZE_US4 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_CNCT_SIZE_US3 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_CNCT_SIZE_US2 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_CNCT_SIZE_US1 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_ERR3_INT_MP_ORD_FIFO_FULL */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* MAC_ERR4_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* MAC_UCD_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* MAC_US_FW_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_phy_interrupts_handler, IMASKED, NULL },/*bit 30 - phy interrupts line*/
	{ docint_default_handler, IMASKED, NULL },
	/* MAC_DS_FW_INT_GROUP */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_PDSP1_KEY_SEQ_ERROR */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_default_handler, IMASKED, NULL },           /* Reserved */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS1 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS2 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS3 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS4 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS5 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS6 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS7 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_INT_MDD_ARRIVED_DS8 */
	{ docint_mask_interrupt_handler, IMASKED, NULL },    /* MAC_DS_FW_PDSP2_SEQ_OUT_OF_RNG_ERROR */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* PHY_INT_GROUP */
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	{ docint_default_handler, IMASKED, NULL },
	/* PHY GRT INT */
    { docint_default_handler, IMASKED, NULL },
};
